;+++++++++++++++++++++++++++++++++++++++++++++++++++
;++++  Simple slider demo. Petezl 2005  ++++++++++++
;+++++++++++++++++++++++++++++++++++++++++++++++++++
.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName db "MyEditClass",0
AppName  db "Slider demo",0
EditClass db "edit",0
EditID equ 1
           
.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
hwndEdit HWND ?
; 

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
; 

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
      LOCAL Wwd :DWORD
      LOCAL Wht :DWORD
      LOCAL Wtx :DWORD
      LOCAL Wty :DWORD
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW-1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,hInstance, 1900
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,10,10,200,150,NULL,NULL,hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
; 

WndProc proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.IF uMsg==WM_CREATE   ; +++  Create child window here as an edit control for input  +++

		INVOKE CreateWindowEx,NULL,ADDR EditClass,NULL,\
                   WS_VISIBLE or WS_CHILD or ES_LEFT or ES_MULTILINE or\
                   ES_AUTOHSCROLL or ES_AUTOVSCROLL or WS_VSCROLL or WS_HSCROLL,0,\
                   0,0,0,hWnd,EditID,\
                   hInstance,NULL
		mov hwndEdit,eax
		invoke SetFocus,hwndEdit

	.ELSEIF uMsg==WM_SIZE   ; +++  Size edit control to fit Client area of main window  +++
		mov eax,lParam
		mov edx,eax
		shr edx,16
		and eax,0ffffh
		invoke MoveWindow,hwndEdit,0,0,eax,edx,TRUE

	.ELSEIF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL

      .elseif uMsg==WM_CLOSE
            invoke DestroyWindow, hWnd
		
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
; 

end start
